#include <bits/stdc++.h>

using namespace std;

#define endl			'\n'

int n, l, r;
int seed;
vector< vector< int > > t;

int a[3][3];

int T;
int cntEmpty;
int win, draw;
vector< string > Log;

string intToStr( int x ) {
	if( x == 0 )
		return "0";
	string res = "";
	while( x ) {
		char c = x % 10 + '0';
		res += c;
		x /= 10;
	}
	reverse( res.begin(), res.end() );
	return res;
}

bool in( int x, int l, int r ) {
	return ( l <= x && x <= r );
}

int getInt( string &s, int &idx ) {
	while( idx < s.size() && s[idx] == ' ' )
		idx ++;
	int res = 0;
	while( idx < s.size() && in( s[idx], '0', '9' ) ) {
		int c = s[idx] - '0';
		res *= 10;
		res += c;
		idx ++;
	}
	return res;
}

bool strEnd( string &s, int &idx ) {
	while( idx < s.size() && s[idx] == ' ' )
		idx ++;
	return ( idx == s.size() );
}

int randNumber( int l, int r ) {
	int x = ( ( rand() << 16 ) + rand() ) % ( r - l + 1 ) + l;
	return x;
}

void stop( int ok, string s ) {
	ofstream out( "output.txt" );
	out << ok << endl;
	out << s << endl;
	out.close();
	exit( 0 );
}

void genTest() {
	vector< int > v;
	v.push_back( 4 );
	for( int i = 0; i < 9; i ++ ) {
		if( i == 4 )
			continue;
		v.push_back( i );
	}
	int i = 0;
	do {
		if( l <= i && i < r )
			t.push_back( v );
		i ++;
	} while( next_permutation( v.begin(), v.end() ) );
	random_shuffle( t.begin(), t.end() );
}

void readTest() {
	fstream test( "input.txt" );
	string type;
	test >> type;
	if( type == "LR" ) {
		test >> l >> r;
		n = r - l;
		seed = l + r;
		srand( seed );
		genTest();
	} else {
		test >> n;
		for( int i = 0; i < n; i ++ ) {
			vector< int > v;
			for( int j = 0; j < 9; j ++ ) {
				int x;
				test >> x;
				v.push_back( x );
			}
			t.push_back( v );
		}
	}
}

void addLog( int p, int x, int y ) {
	string c = ( p == 1 ? "X" : "O" );
	Log.push_back( "Go " + c + ": " + intToStr( x + 1 ) + " " + intToStr( y + 1 ) );
}

string getLog() {
	string res = "\n\n";
	for( int i = 0; i < Log.size(); i ++ ) {
		res += Log[i];
		res += "\n";
	}
	res += "\n";
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			if( a[i][j] == 0 )
				res += "   ";
			else if( a[i][j] == 1 )
				res += " X ";
			else
				res += " O ";
			if( j < 2 )
				res += "|";
		}
		if( i < 2 ) {
			res += "\n";
			res += "---+---+---";
			res += "\n";
		}
	}
	return res;
}

void go( int x, int y, bool lose = false ) {
	if( lose )
		cout << "lose" << endl;
	else
		cout << "go" << endl;
	a[x][y] = 2;
	cout << x + 1 << " " << y + 1 << endl;
	cout.flush();
	addLog( 2, x, y );
}

void del() {
	Log.clear();
	Log.push_back( "Last game:" );
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			a[i][j] = 0;
		}
	}
}

string info() {
	return 	"\nWin in " + intToStr( win ) + " games. " +
			"\nDraw in " + intToStr( draw ) + " games. ";
}

bool checkWin( int x ) {
	for( int i = 0; i < 3; i ++ ) {
		int cnt = 0;
		for( int j = 0; j < 3; j ++ ) {
			cnt += ( a[i][j] == x );
		}
		if( cnt == 3 )
			return true;
	}
	for( int i = 0; i < 3; i ++ ) {
		int cnt = 0;
		for( int j = 0; j < 3; j ++ ) {
			cnt += ( a[j][i] == x );
		}
		if( cnt == 3 )
			return true;
	}
	if( a[0][0] == x && a[1][1] == x && a[2][2] == x )
		return true;
	if( a[2][0] == x && a[1][1] == x && a[0][2] == x )
		return true;
	return false;
}

bool checkDraw() {
	int cnt = 0;
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			cnt += ( a[i][j] != 0 );
		}
	}
	if( cnt == 9 )
		return true;
	return false;
}

bool checkLose() {
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			if( a[i][j] )
				continue;
			a[i][j] = 2;
			if( checkWin( 2 ) ) {
				go( i, j, true );
				return true;
			}
			a[i][j] = 0;
		}
	}
	return false;
}

bool checkBlock() {
	for( int i = 0; i < 3; i ++ ) {
		for( int j = 0; j < 3; j ++ ) {
			if( a[i][j] )
				continue;
			a[i][j] = 1;
			if( checkWin( 1 ) ) {
				go( i, j );
				return true;
			}
			a[i][j] = 0;
		}
	}
	return false;
}

void go( int &idx, vector< int > &v ) {
	if( checkLose() )
		stop( 1, "Lose in " + intToStr( T+1 ) + " game." + getLog() );
	if( checkBlock() )
		return;
	for( ; idx < 9; idx ++ ) {
		int x = v[idx] / 3;
		int y = v[idx] % 3;
		if( a[x][y] )
			continue;
		go( x, y );
		break;
	}
	return;
}

void game( vector< int > v ) {
	del();
	int idx = 0;
	while( true ) {
		string s;
		getline( cin, s );
		if( s.size() == 0 ) {
			cntEmpty ++;
			if( cntEmpty > 1e6 )
				stop( 2, "Empty stdin." );
			continue;
		}
		if( s.size() > 100 )
			stop( 2, "Bad requests (long)." );
		int jdx = 0;
		int x = getInt( s, jdx ) - 1;
		int y = getInt( s, jdx ) - 1;
		if( !strEnd( s, jdx ) )
			stop( 2, "Bad requests (format): " + s );
		if( !in( x, 0, 2 ) || !in( y, 0, 2 ) )
			stop( 2, "Bad requests (bad x or y): " + s );
		if( a[x][y] )
			stop( 2, "The cell is busy: " + s );
		a[x][y] = 1;
		addLog( 1, x, y );
		if( checkWin( 1 ) ) {
			win ++;
			cout << "win" << endl;
			cout.flush();
			break;
		}
		if( checkDraw() ) {
			draw ++;
			cout << "draw" << endl;
			cout.flush();
			break;
		}
		go( idx, v );
	}
}

int main( int argc, char *argv[] ) {
	readTest();

	cout << n << endl;
	cout.flush();

	for( T = 0; T < n; T ++ ) {
		game( t[T] );
	}
	stop( 0, "Ok. " + info() );
	return 0;
}
